﻿if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[i%.][t%.][B%.]ull\\Modules\\(.-)\\") or debugstack():match("[i%.][t%.][B%.]ull\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 67030 $"):match("%d+"))

local PitBull = PitBull
local PitBull_MultiBoxer_PartyExperienceBar = PitBull:NewModule("MultiBoxer-PartyExperienceBar", "LibRockEvent-1.0","LibRockComm-1.0")
local self = PitBull_MultiBoxer_PartyExperienceBar
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2008-03-30 01:33:10 -0400 (Sun, 30 Mar 2008) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local localization = {}
local xpdata = {}
PitBull_MultiBoxer_PartyExperienceBar.OnCommReceive = {}

local L = PitBull:L("PitBull-MultiBoxer-ExperienceBar", localization)

self.desc = L["Show an experience bar on the unit frame."]

local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame

PitBull_MultiBoxer_PartyExperienceBar:RegisterPitBullChildFrames('mp_party_expBar')
PitBull_MultiBoxer_PartyExperienceBar:RegisterPitBullBarLayoutHandler("mp_party_expBar", L["MultiBoxer Party Experience bar"], L["Experience"])

function PitBull_MultiBoxer_PartyExperienceBar:OnInitialize()
	self.db = PitBull:GetDatabaseNamespace("mpExperienceBar")
	PitBull:SetDatabaseNamespaceDefaults("mpExperienceBar", "profile", {
		['**'] = {
			ignore = false,
		},
		player = {
			ignore = true,
		},
		colors = {0, 0, 1},
		restColors = {1, 0, 1},
		bgColors = {0, 0, 0},
	})
	
	self:SetDefaultCommPriority("ALERT")
	self:AddCommListener("MultiBoxer", "GROUP")
end

function PitBull_MultiBoxer_PartyExperienceBar:OnEnable(first)

end

function PitBull_MultiBoxer_PartyExperienceBar.OnCommReceive:XPGAIN(prefix, distribution, sender, xpperc,xpcur,xpmax)
	for i=1, GetNumPartyMembers() do
		if (UnitName("party"..i) == sender) then
			xpdata[sender] = {}
			xpdata[sender]["xpperc"] = xpperc
			xpdata[sender]["xpcur"] = xpcur
			xpdata[sender]["xpmax"] = xpmax
			self:UpdateExperience("party"..i)
			return		
		end
	end
end

function PitBull_MultiBoxer_PartyExperienceBar:UpdateExperience(unit, frame)
	if not unit then
		return
	end
	if not frame then
		for frame in PitBull:IterateUnitFramesForUnit(unit) do
			self:UpdateExperience(unit, frame)
		end
		return
	end
	
	if self.db.profile[unit].ignore or UnitLevel(unit) == MAX_PLAYER_LEVEL then
		if frame.mp_party_expBar then
			PitBull_MultiBoxer_PartyExperienceBar:OnClearUnitFrame(unit, frame)
			PitBull:UpdateLayout(frame)
		end
		return
	else
		if not frame.mp_party_expBar then
			PitBull_MultiBoxer_PartyExperienceBar:OnPopulateUnitFrame(unit, frame)
			PitBull:UpdateLayout(frame)
		end
	end
	
	local current, max
	if (xpdata[UnitName(unit)] ~= nil) then
		current = xpdata[UnitName(unit)]["xpcur"]
		max = xpdata[UnitName(unit)]["xpmax"]	
	else
		if frame.mp_party_expBar then
			PitBull_MultiBoxer_PartyExperienceBar:OnClearUnitFrame(unit, frame)
			PitBull:UpdateLayout(frame)
		end
		return
	end

	if max == 0 then
		current = 0
		max = 1
	end
	local rest = 0
	frame.mp_party_expBar:SetValue(current / max)
	frame.mp_party_expBar:SetExtraValue(rest / max)
	local r, g, b = unpack(self.db.profile.colors)
	local br, bg, bb = unpack(self.db.profile.bgColors)
	local rr, rg, rb = unpack(self.db.profile.restColors)
	frame.mp_party_expBar:SetColor(r, g, b)
	frame.mp_party_expBar:SetBackgroundColor(br, bg, bb)
	frame.mp_party_expBar:SetExtraColor(rr, rg, rb)
end

function PitBull_MultiBoxer_PartyExperienceBar:OnUpdateFrame(unit, frame)
	if unit == "party1" or unit == "party2" or unit == "party3" or unit == "party4" or unit == "party5" then 
		self:UpdateExperience(unit, frame)
	end
end

function PitBull_MultiBoxer_PartyExperienceBar:OnPopulateUnitFrame(unit, frame)
	if frame.mp_party_expBar or self.db.profile[unit].ignore or UnitLevel(unit) == MAX_PLAYER_LEVEL then
		return 
	end
	if unit == "party1" or unit == "party2" or unit == "party3" or unit == "party4" or unit == "party5" then 
		local mp_party_expBar = newFrame("FakeStatusBar", frame)
		frame.mp_party_expBar = mp_party_expBar
		mp_party_expBar:SetTexture(PitBull:GetStatusBarTexture())
		mp_party_expBar:SetColor(0, 0, 1, 1)
	end
end

function PitBull_MultiBoxer_PartyExperienceBar:OnClearUnitFrame(unit, frame)
	if frame.mp_party_expBar then
		frame.mp_party_expBar = delFrame(frame.mp_party_expBar)
	end
end

function PitBull_MultiBoxer_PartyExperienceBar:OnUpdateStatusBarTexture(texture)
	for i=1, GetNumPartyMembers() do
		for frame in PitBull:IterateUnitFramesForUnit("party"..i) do
			if frame.mp_party_expBar then
				frame.mp_party_expBar:SetTexture(texture)
			end
		end
	end
end

local function getDisabled(group)
	return self.db.profile[group].ignore
end
local function getEnabled(group)
	return not self.db.profile[group].ignore
end

local function setEnabled(group, value)
	self.db.profile[group].ignore = not value
	PitBull_MultiBoxer_PartyExperienceBar:UpdateExperience(group)
end

PitBull:RegisterGlobalSetting("colors", "args", "experiencebar", function() return "@cache", {
	type = 'group',
	name = L["Party Experience"],
	desc = L["Set the colors for the experience bar."],
	args = {
		bar = {
			type = 'color',
			name = L["Color"],
			desc = L["Set the color for the experience bar."],
			get = function()
				return unpack(PitBull_MultiBoxer_PartyExperienceBar.db.profile.colors)
			end,
			set = function(r, g, b)
				PitBull_MultiBoxer_PartyExperienceBar.db.profile.colors = {r, g, b}

				PitBull_MultiBoxer_PartyExperienceBar:UpdateExperience()
			end,
		},
		background = {
			type = 'color',
			name = L["Background color"],
			desc = L["Set the background color for the experience bar."],
			get = function()
				return unpack(PitBull_MultiBoxer_PartyExperienceBar.db.profile.bgColors)
			end,
			set = function(r, g, b)
				PitBull_MultiBoxer_PartyExperienceBar.db.profile.bgColors = {r, g, b}

				PitBull_MultiBoxer_PartyExperienceBar:UpdateExperience()
			end,
		},
		resting = {
			type = 'color',
			name = L["Rest color"],
			desc = L["Set the color for rested experience on the bar."],
			get = function()
				return unpack(PitBull_MultiBoxer_PartyExperienceBar.db.profile.restColors)
			end,
			set = function(r, g, b)
				PitBull_MultiBoxer_PartyExperienceBar.db.profile.restColors = {r, g, b}

				PitBull_MultiBoxer_PartyExperienceBar:UpdateExperience()
			end,
		},
	},
} end)

PitBull_MultiBoxer_PartyExperienceBar:RegisterPitBullOptionsMethod(function(group)
	if group == "party1" or group == "party2" or group == "party3" or group == "party4" or group == "party5" then 
		return {
			name = L["Experience"],
			desc = L["Options for the units experience bar."],
			type = 'group',
			args = {
				ignore = {
					type = 'boolean',
					name = L["Enable"],
					desc = L["Enable the experience bar."],
					get = getEnabled,
					set = setEnabled,
					passValue = group,
					order = 1,
				},
			}
		}
	end
end)

